Module ConfigFunctions
    Public Function CleanUpHTML(ByVal CleanString As String, Optional ByVal SpecialChars As Boolean = False) As String
        CleanString = CleanString.Replace("&nbsp;", "")
        If SpecialChars = True Then
            CleanString = CleanString.Replace("&#252;", "").Replace("&uuml;", "")
            CleanString = CleanString.Replace("&#228;", "").Replace("&auml;", "")
            CleanString = CleanString.Replace("&#246;", "").Replace("&ouml;", "")
            CleanString = CleanString.Replace("&#220;", "").Replace("&Uuml;", "")
            CleanString = CleanString.Replace("&#196;", "").Replace("&Auml;", "")
            CleanString = CleanString.Replace("&#214;", "").Replace("&Ouml;", "")
            CleanString = CleanString.Replace("&#223;", "").Replace("&szlig;", "")
        End If
        Return CleanString
    End Function

    Public Sub LoadConfig()
        Dim TempString As String
        Dim ConfigArray() As String
        With Config.FahrPlanErstellen
            TempString = LoadFile(AppPath & "\Config\config.cfg")
            ConfigArray = Split(TempString, vbNewLine)
            With .ConfigKeepSave
                .LastStartOrt = ConfigArray(0)
                .LastStartHalteStelle = ConfigArray(1)
                .LastEndOrt = ConfigArray(2)
                .LastEndHalteStelle = ConfigArray(3)
            End With
            .AbfahrtOrAnkunft = ConfigArray(4)
            With .Standard
                .StartOrt = ConfigArray(5)
                .StartHalteStelle = ConfigArray(6)
                .EndOrt = ConfigArray(7)
                .EndHalteStelle = ConfigArray(8)
            End With
        End With
        Config.TemplateName = ConfigArray(9)
        Config.TemplatePath = AppPath & "\Templates\HTML\" & Config.TemplateName
        Config.TemplateFile = Config.TemplatePath & "\template.htm"
        Config.Provider = ConfigArray(10)
        If Config.Provider = "" Then Config.Provider = "Deutsche Bahn"

        TempString = LoadFile(AppPath & "\Config\proxy.cfg")
        ConfigArray = Split(TempString, vbNewLine)
        Config.NeedProxy = ConfigArray(0)
        Config.ProxyURL = ConfigArray(1)
        Config.ProxyPort = ConfigArray(2)
        Config.ProxyUser = ConfigArray(3)
        Config.ProxyPass = ConfigArray(4)
    End Sub

    Public Sub SaveConfig()
        Dim TempString As String
        With Config.FahrPlanErstellen
            TempString = _
            .LastStartOrt & vbNewLine & _
            .LastStartHalteStelle & vbNewLine & _
            .LastEndOrt & vbNewLine & _
            .LastEndHalteStelle & vbNewLine & _
            .AbfahrtOrAnkunft & vbNewLine & _
            .Standard.StartOrt & vbNewLine & _
            .Standard.StartHalteStelle & vbNewLine & _
            .Standard.EndOrt & vbNewLine & _
            .Standard.EndHalteStelle & vbNewLine & _
            Config.TemplateName & vbNewLine & _
            Config.Provider
            SaveFile(AppPath & "\Config\config.cfg", TempString)
        End With

        With Config
            TempString = _
             .NeedProxy & vbNewLine & _
             .ProxyURL & vbNewLine & _
             .ProxyPort & vbNewLine & _
             .ProxyUser & vbNewLine & _
             .ProxyPass
            SaveFile(AppPath & "\Config\proxy.cfg", TempString)
        End With
    End Sub

    Public Sub LoadLastFahrPlan()
        Dim TempString As String
        Dim LastFahrplanArray() As String
        With Config.FahrPlanErstellen
            TempString = LoadFile(AppPath & "\Config\lastFahrplan.txt")
            LastFahrplanArray = Split(TempString, vbNewLine)
            With Config.FahrPlanErstellen
                If .ConfigKeepSave.LastStartOrt <> "Keep" Then
                    .LastStartOrt = LastFahrplanArray(0)
                Else
                    .LastStartOrt = .Standard.StartOrt
                End If
                If .ConfigKeepSave.LastStartHalteStelle <> "Keep" Then
                    .LastStartHalteStelle = LastFahrplanArray(1)
                Else
                    .LastStartHalteStelle = .Standard.StartHalteStelle
                End If
                If .ConfigKeepSave.LastEndOrt <> "Keep" Then
                    .LastEndOrt = LastFahrplanArray(2)
                Else
                    .LastEndOrt = .Standard.EndOrt
                End If
                If .ConfigKeepSave.LastEndHalteStelle <> "Keep" Then
                    .LastEndHalteStelle = LastFahrplanArray(3)
                Else
                    .LastEndHalteStelle = .Standard.EndHalteStelle
                End If
            End With
        End With
    End Sub

    Public Sub SaveLastFahrPlan()
        Dim TempString As String
        With Config.FahrPlanErstellen
            If .ConfigKeepSave.LastStartOrt <> "Keep" Then
                .LastStartOrt = frmFahrplan.cmbStartOrt.Text
            Else
                .LastStartOrt = .Standard.StartOrt
            End If
            If .ConfigKeepSave.LastStartHalteStelle <> "Keep" Then
                .LastStartHalteStelle = frmFahrplan.cmbStartHalteStelle.Text
            Else
                .LastStartHalteStelle = .Standard.StartHalteStelle
            End If
            If .ConfigKeepSave.LastEndOrt <> "Keep" Then
                .LastEndOrt = frmFahrplan.cmbEndOrt.Text
            Else
                .LastEndOrt = .Standard.EndOrt
            End If
            If .ConfigKeepSave.LastEndHalteStelle <> "Keep" Then
                .LastEndHalteStelle = frmFahrplan.cmbEndHalteStelle.Text
            Else
                .LastEndHalteStelle = .Standard.EndHalteStelle
            End If

            TempString = _
            .LastStartOrt & vbNewLine & _
            .LastStartHalteStelle & vbNewLine & _
            .LastEndOrt & vbNewLine & _
            .LastEndHalteStelle
        End With
        SaveFile(AppPath & "\Config\lastFahrplan.txt", TempString)
    End Sub

    Public Sub SaveFavorite(ByVal FilePath As String)
        Dim TempString(1) As String
        With ErstellterFahrplan
            TempString(1) = ErstellterFahrplan.StartOrt
            TempString(2) = ErstellterFahrplan.StartHalteStelle
            TempString(3) = ErstellterFahrplan.EndOrt
            TempString(4) = ErstellterFahrplan.EndHalteStelle
            TempString(5) = ErstellterFahrplan.Umstiege
            TempString(6) = ErstellterFahrplan.UhrZeit.Minuten
            TempString(7) = ErstellterFahrplan.UhrZeit.Stunden
            TempString(8) = ErstellterFahrplan.Datum.Jahr
            TempString(9) = ErstellterFahrplan.Datum.Monat
            TempString(10) = ErstellterFahrplan.Datum.Tag
            TempString(11) = ErstellterFahrplan.LinienArt
        End With
    End Sub

    Public Sub SaveRawFahrplan2(ByVal FilePath As String)
        Dim RawFahrplan As String = ""
        Dim iCounterGroup, iSpecialID As Byte

        RawFahrplan = "(" & FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten & ")"

        With ErstellterFahrplan
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .StartOrt
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .StartHalteStelle
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .EndOrt
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .EndHalteStelle

            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .AbfahrtOrAnkunft

            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .UhrZeit.Stunden
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .UhrZeit.Minuten
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .Datum.Tag
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .Datum.Monat
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]" & .Datum.Jahr
            RawFahrplan = RawFahrplan & "[<ErstellterFahrplan>]"
        End With

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            With FahrPlan(iCounterGroup, 0).FahrPlanOverView
                RawFahrplan = RawFahrplan & "[<Overview>]" & .Datum
                RawFahrplan = RawFahrplan & "[<Overview>]" & .StartZeit
                RawFahrplan = RawFahrplan & "[<Overview>]" & .EndZeit
                RawFahrplan = RawFahrplan & "[<Overview>]" & .FahrtDauer
                RawFahrplan = RawFahrplan & "[<Overview>]" & .Umstiege
            End With
        Next
        RawFahrplan = RawFahrplan & "[<Overview>]"

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            For iSpecialID = 1 To FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
                RawFahrplan = RawFahrplan & "(" & FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips & ")"
                With FahrPlan(iCounterGroup, iSpecialID).FahrplanMain
                    RawFahrplan = RawFahrplan & "[<Special>]" & .StartZeit
                    RawFahrplan = RawFahrplan & "[<Special>]" & .StartPunkt
                    RawFahrplan = RawFahrplan & "[<Special>]" & .FahrZeugTyp
                    RawFahrplan = RawFahrplan & "[<Special>]" & .EndZeit
                    RawFahrplan = RawFahrplan & "[<Special>]" & .StartPunkt
                End With
            Next
            RawFahrplan = RawFahrplan & "[<Special>]"
        Next
        SaveFile(FilePath, RawFahrplan)
    End Sub

    Public Sub LoadRawFahrplan2(ByVal FilePath As String)
        Dim RawFahrplan As String = ""
        Dim StripTag As String
        Dim StripLen As Byte
        Dim iCounterGroup, iSpecialID As Byte

        RawFahrplan = LoadFile(FilePath)
        RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, "(") + 1)
        FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten = Left(RawFahrplan, InStr(RawFahrplan, ")") - 1)
        With ErstellterFahrplan
            StripTag = "[<ErstellterFahrplan>]"
            StripLen = Len(StripTag)

            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .StartOrt = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .StartHalteStelle = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .EndOrt = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .EndHalteStelle = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .AbfahrtOrAnkunft = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .UhrZeit.Stunden = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .UhrZeit.Minuten = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .Datum.Tag = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .Datum.Monat = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
            .Datum.Jahr = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
        End With

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            With FahrPlan(iCounterGroup, 0).FahrPlanOverView
                StripTag = "[<Overview>]"
                StripLen = Len(StripTag)

                RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                .Datum = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                .StartZeit = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                .EndZeit = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                .FahrtDauer = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                .Umstiege = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
            End With
        Next

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, "(") + 1)
            FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips = Left(RawFahrplan, InStr(RawFahrplan, ")") - 1)
            For iSpecialID = 1 To FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
                With FahrPlan(iCounterGroup, iSpecialID).FahrplanMain
                    StripTag = "[<Special>]"
                    StripLen = Len(StripTag)

                    RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                    .StartZeit = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                    RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                    .StartPunkt = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                    RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                    .FahrZeugTyp = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                    RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                    .EndZeit = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                    RawFahrplan = Mid(RawFahrplan, InStr(RawFahrplan, StripTag) + StripLen)
                    .StartPunkt = Left(RawFahrplan, InStr(RawFahrplan, StripTag) - 1)
                End With
            Next
        Next

        With frmFahrplan
            If ErstellterFahrplan.AbfahrtOrAnkunft = "dep" Then
                .chkAbfahrt.Checked = True
            Else
                .chkAnkunft.Checked = True
            End If
            .cmbStartOrt.Text = ErstellterFahrplan.StartOrt
            .cmbStartHalteStelle.Text = ErstellterFahrplan.StartHalteStelle
            .cmbEndOrt.Text = ErstellterFahrplan.EndOrt
            .cmbEndHalteStelle.Text = ErstellterFahrplan.EndHalteStelle
            '.dtpDatum.Value = System.DateTime.Now
            'Find a Way do Set Date in the Date Panel...
            .trbStunden.Value = ErstellterFahrplan.UhrZeit.Stunden
            .trbMinuten.Value = ErstellterFahrplan.UhrZeit.Minuten
            .txtZeit.Text = FormatTimeString(.trbStunden.Value, .trbMinuten.Value)
        End With
    End Sub

    Public Sub SaveRawFahrplan(ByVal FilePath As String)
        Dim RawFahrplan As String = ""
        Dim iCounterGroup, iSpecialID As Byte

        RawFahrplan = "SciLor's Fahrplanauskunft v" & Version & " - Fahrplan"

        RawFahrplan &= "[<Part>]"

        RawFahrplan &= "[<ErstellterFahrplan>]" & FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
        With ErstellterFahrplan
            RawFahrplan &= "[<ErstellterFahrplan>]" & .StartOrt
            RawFahrplan &= "[<ErstellterFahrplan>]" & .StartHalteStelle
            RawFahrplan &= "[<ErstellterFahrplan>]" & .EndOrt
            RawFahrplan &= "[<ErstellterFahrplan>]" & .EndHalteStelle

            RawFahrplan &= "[<ErstellterFahrplan>]" & .AbfahrtOrAnkunft

            RawFahrplan &= "[<ErstellterFahrplan>]" & .UhrZeit.Stunden
            RawFahrplan &= "[<ErstellterFahrplan>]" & .UhrZeit.Minuten
            RawFahrplan &= "[<ErstellterFahrplan>]" & .Datum.Tag
            RawFahrplan &= "[<ErstellterFahrplan>]" & .Datum.Monat
            RawFahrplan &= "[<ErstellterFahrplan>]" & .Datum.Jahr
        End With

        RawFahrplan &= "[<Part>]"

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            RawFahrplan &= "[<OverviewGroup>]"
            With FahrPlan(iCounterGroup, 0).FahrPlanOverView
                RawFahrplan &= "[<Overview>]" & .Datum
                RawFahrplan &= "[<Overview>]" & .StartZeit
                RawFahrplan &= "[<Overview>]" & .EndZeit
                RawFahrplan &= "[<Overview>]" & .FahrtDauer
                RawFahrplan &= "[<Overview>]" & .Umstiege
            End With
        Next

        RawFahrplan &= "[<Part>]"

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            RawFahrplan &= "[<SpecialGroup>]" & FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
            For iSpecialID = 1 To FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
                RawFahrplan &= "[<SpecialTrip>]"
                With FahrPlan(iCounterGroup, iSpecialID).FahrplanMain
                    RawFahrplan &= "[<Special>]" & .StartZeit
                    RawFahrplan &= "[<Special>]" & .StartPunkt
                    RawFahrplan &= "[<Special>]" & .FahrZeugTyp
                    RawFahrplan &= "[<Special>]" & .EndZeit
                    RawFahrplan &= "[<Special>]" & .EndPunkt
                End With
            Next
        Next

        RawFahrplan = Replace(RawFahrplan, ChrW(10), "")
        RawFahrplan = Replace(RawFahrplan, "[<Part>]", vbNewLine & "[<Part>]" & vbNewLine)

        SaveFile(FilePath, CleanUpHTML(RawFahrplan))
    End Sub

    Public Sub LoadRawFahrplan(ByVal FilePath As String)
        Dim RawFahrplan As String = ""

        Dim AllPartsArray(3) As String

        Dim ErstellterFahrplanArray(11) As String

        Dim OverviewGroupArray(64) As String
        Dim OverviewArray(5) As String

        Dim SpecialGroupArray(64) As String
        Dim SpecialTripArray(64) As String
        Dim SpecialArray(5) As String

        Dim iCounterGroup, iSpecialID As Byte

        RawFahrplan = LoadFile(FilePath)
        If RawFahrplan.StartsWith("SciLor's Fahrplanauskunft") = True Then
            AllPartsArray = Split(RawFahrplan, vbNewLine & "[<Part>]" & vbNewLine, 4)
            ErstellterFahrplanArray = Split(AllPartsArray(1), "[<ErstellterFahrplan>]", 12)


            FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten = ErstellterFahrplanArray(1)
            With ErstellterFahrplan
                .StartOrt = ErstellterFahrplanArray(2)
                .StartHalteStelle = ErstellterFahrplanArray(3)
                .EndOrt = ErstellterFahrplanArray(4)
                .EndHalteStelle = ErstellterFahrplanArray(5)

                .AbfahrtOrAnkunft = ErstellterFahrplanArray(6)

                .UhrZeit.Stunden = ErstellterFahrplanArray(7)
                .UhrZeit.Minuten = ErstellterFahrplanArray(8)
                .Datum.Tag = ErstellterFahrplanArray(9)
                .Datum.Monat = ErstellterFahrplanArray(10)
                .Datum.Jahr = ErstellterFahrplanArray(11)
            End With

            OverviewGroupArray = Split(AllPartsArray(2), "[<OverviewGroup>]", 65)
            For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
                OverviewArray = Split(OverviewGroupArray(iCounterGroup), "[<Overview>]", 6)
                With FahrPlan(iCounterGroup, 0).FahrPlanOverView
                    .Datum = OverviewArray(1)
                    .StartZeit = OverviewArray(2)
                    .EndZeit = OverviewArray(3)
                    .FahrtDauer = OverviewArray(4)
                    .Umstiege = OverviewArray(5)
                End With
            Next

            SpecialGroupArray = Split(AllPartsArray(3), "[<SpecialGroup>]", 65)
            For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
                SpecialTripArray = Split(SpecialGroupArray(iCounterGroup), "[<SpecialTrip>]", 65)
                FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips = SpecialTripArray(0).Trim("(").Trim(")")
                For iSpecialID = 1 To FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
                    SpecialArray = Split(SpecialTripArray(iSpecialID), "[<Special>]", 6)
                    With FahrPlan(iCounterGroup, iSpecialID).FahrplanMain
                        .StartZeit = SpecialArray(1)
                        .StartPunkt = SpecialArray(2)
                        .FahrZeugTyp = SpecialArray(3)
                        .EndZeit = SpecialArray(4)
                        .EndPunkt = SpecialArray(5)
                    End With
                Next
            Next

            With frmFahrplan
                If ErstellterFahrplan.AbfahrtOrAnkunft = "dep" Then
                    .chkAbfahrt.Checked = True
                Else
                    .chkAnkunft.Checked = True
                End If
                .cmbStartOrt.Text = ErstellterFahrplan.StartOrt
                .cmbStartHalteStelle.Text = ErstellterFahrplan.StartHalteStelle
                .cmbEndOrt.Text = ErstellterFahrplan.EndOrt
                .cmbEndHalteStelle.Text = ErstellterFahrplan.EndHalteStelle
                '.dtpDatum.Value = System.DateTime.Now
                'Find a Way do Set Date in the Date Panel...
                .trbStunden.Value = ErstellterFahrplan.UhrZeit.Stunden
                .trbMinuten.Value = ErstellterFahrplan.UhrZeit.Minuten
                .txtZeit.Text = FormatTimeString(.trbStunden.Value, .trbMinuten.Value)
            End With
        ElseIf RawFahrplan.StartsWith("(") = True And InStr(RawFahrplan, "[<ErstellterFahrplan>]") > 0 Then
            frmFahrplan.TopMost = False
            MsgBox("Fahrplan nicht kompatibel" & vbNewLine & "Bitte neuen erstellen!")
            frmFahrplan.TopMost = True
        Else
            frmFahrplan.TopMost = False
            MsgBox("Das ist kein Fahrplan!")
            frmFahrplan.TopMost = True
        End If
    End Sub

    Public Sub SaveConfigs()
        Call SaveConfig()
        Call SaveLastFahrPlan()
        Call LoadConfigs()
    End Sub

    Public Sub QuickListToConfig(Optional ByVal Orte As Boolean = False, Optional ByVal HalteStellen As Boolean = False)
        Dim TempCounter As Byte
        With frmFahrplan.cmbEinstellungen
            If Orte = True Then
                For TempCounter = 0 To QuickList.StaedteAnzahl - 1
                    If QuickList.Staedte(TempCounter) = "" Then Exit For
                    .Items.Add(QuickList.Staedte(TempCounter))
                Next
            ElseIf HalteStellen = True Then
                For TempCounter = 0 To QuickList.HalteStellenAnzahl - 1
                    If QuickList.HalteStellen(TempCounter) = "" Then Exit For
                    .Items.Add(QuickList.HalteStellen(TempCounter))
                Next
            End If
        End With
    End Sub

    Public Sub ChangeConfigMenu(ByVal TreeViewText As String, Optional ByVal SaveConfig As Boolean = False)
        With frmFahrplan.cmbEinstellungen
            'If .Text = "" Then SaveConfig = False
            If SaveConfig = False Then
                Config.OldFahrPlanNode = TreeViewText
                frmFahrplan.lblEinstellungen.Text = frmFahrplan.tvwConfig.SelectedNode.Tag
                .Items.Clear()
            End If

            Select Case TreeViewText
                Case "Provider"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Deutsche Bahn")
                        .Items.Add("VRR.de")
                        .Text = Config.Provider
                    Else
                        Config.Provider = .Text
                    End If
                Case "Abfahrtsort Std."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        Call QuickListToConfig(True, False)
                        .Text = Config.FahrPlanErstellen.Standard.StartOrt
                    Else
                        Config.FahrPlanErstellen.Standard.StartOrt = .Text
                    End If
                Case "Abfahrtshaltestelle Std."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        Call QuickListToConfig(False, True)
                        .Text = Config.FahrPlanErstellen.Standard.StartHalteStelle
                    Else
                        Config.FahrPlanErstellen.Standard.StartHalteStelle = .Text
                    End If
                Case "Ankunftsort Std."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        Call QuickListToConfig(True, False)
                        .Text = Config.FahrPlanErstellen.Standard.EndOrt
                    Else
                        Config.FahrPlanErstellen.Standard.EndOrt = .Text
                    End If
                Case "Ankunftshaltestelle Std."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        Call QuickListToConfig(False, True)
                        .Text = Config.FahrPlanErstellen.Standard.EndHalteStelle
                    Else
                        Config.FahrPlanErstellen.Standard.EndHalteStelle = .Text
                    End If

                Case "Abfahrtsort bht."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Alten Wert behalten")
                        .Items.Add("Auf Standard zurckgreifen")
                        If Config.FahrPlanErstellen.ConfigKeepSave.LastStartOrt = "Keep" Then
                            .Text = "Auf Standard zurckgreifen"
                        Else
                            .Text = "Alten Wert behalten"
                        End If
                    Else
                        If .Text = "Alten Wert behalten" Then
                            Config.FahrPlanErstellen.ConfigKeepSave.LastStartOrt = "DontKeep"
                        Else
                            Config.FahrPlanErstellen.ConfigKeepSave.LastStartOrt = "Keep"
                        End If
                    End If
                Case "Abfahrtshaltestelle bht."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Alten Wert behalten")
                        .Items.Add("Auf Standard zurckgreifen")
                        If Config.FahrPlanErstellen.ConfigKeepSave.LastStartHalteStelle = "Keep" Then
                            .Text = "Auf Standard zurckgreifen"
                        Else
                            .Text = "Alten Wert behalten"
                        End If
                    Else
                        If .Text = "Alten Wert behalten" Then
                            Config.FahrPlanErstellen.ConfigKeepSave.LastStartHalteStelle = "DontKeep"
                        Else
                            Config.FahrPlanErstellen.ConfigKeepSave.LastStartHalteStelle = "Keep"
                        End If
                    End If
                Case "Ankunftsort bht."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Alten Wert behalten")
                        .Items.Add("Auf Standard zurckgreifen")
                        If Config.FahrPlanErstellen.ConfigKeepSave.LastEndOrt = "Keep" Then
                            .Text = "Auf Standard zurckgreifen"
                        Else
                            .Text = "Alten Wert behalten"
                        End If
                    Else
                        If .Text = "Alten Wert behalten" Then
                            Config.FahrPlanErstellen.ConfigKeepSave.LastEndOrt = "DontKeep"
                        Else
                            Config.FahrPlanErstellen.ConfigKeepSave.LastEndOrt = "Keep"
                        End If
                    End If
                Case "Ankunftshaltestelle bht."
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Alten Wert behalten")
                        .Items.Add("Auf Standard zurckgreifen")
                        If Config.FahrPlanErstellen.ConfigKeepSave.LastEndHalteStelle = "Keep" Then
                            .Text = "Auf Standard zurckgreifen"
                        Else
                            .Text = "Alten Wert behalten"
                        End If
                    Else
                        If .Text = "Alten Wert behalten" Then
                            Config.FahrPlanErstellen.ConfigKeepSave.LastEndHalteStelle = "DontKeep"
                        Else
                            Config.FahrPlanErstellen.ConfigKeepSave.LastEndHalteStelle = "Keep"
                        End If
                    End If

                Case "Abfahrt o. Ankunft"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Abfahrt")
                        .Items.Add("Ankunft")
                        .Text = Config.FahrPlanErstellen.AbfahrtOrAnkunft
                    Else
                        Config.FahrPlanErstellen.AbfahrtOrAnkunft = .Text
                    End If
                Case "Template"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        For Each Template In TemplateNames
                            If Template = vbNullString Then Exit For
                            .Items.Add(Template)
                        Next
                        .Text = Config.TemplateName
                    Else
                        Config.TemplateName = .Text
                    End If
                Case "Proxy Enabled"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDownList
                        .Items.Add("Nein")
                        .Items.Add("Ja")
                        .Text = Config.NeedProxy
                    Else
                        Config.NeedProxy = .Text
                    End If
                Case "Proxy URL"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        .Text = Config.ProxyURL
                    Else
                        Config.ProxyURL = .Text
                    End If
                Case "Proxy Port"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        .Text = Config.ProxyPort
                    Else
                        Config.ProxyPort = .Text
                    End If
                Case "Proxy Username"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        .Text = Config.ProxyUser
                    Else
                        Config.ProxyUser = .Text
                    End If
                Case "Proxy Passwort"
                    If SaveConfig = False Then
                        .DropDownStyle = ComboBoxStyle.DropDown
                        .Text = Config.ProxyPass
                    Else
                        Config.ProxyPass = .Text
                    End If
            End Select
        End With
    End Sub
End Module
