Module StartUpFunctions
    Public Sub MonthControlFix()
        TempDate.Tag = System.DateTime.Today.Day
        TempDate.Monat = System.DateTime.Today.Month
        TempDate.Jahr = System.DateTime.Today.Year
    End Sub

    Public Sub PicsToVars()
        With frmFahrplan.imgButtonList.Images
            imgThumbButtonCheck = .Item(0)
            imgThumbButtonBack = .Item(1)
            imgThumbButtonDown = .Item(2)
        End With
        With frmFahrplan.imgMenu.Images
            imgMenuButtonFahrplanErstellen = .Item(0)
            imgMenuButtonFavoriten = .Item(1)
            imgMenuButtonEinstellungen = .Item(2)
            imgMenuButtonHelp = .Item(3)
            imgMenuButtonExit = .Item(4)
            imgMenuButtonUp = .Item(5)
            imgMenuButtonDown = .Item(6)
        End With
    End Sub

    Public Sub PicsToControls()
        With frmFahrplan
            .picCheck.Image = imgThumbButtonCheck
            .picBack.Image = imgThumbButtonBack

            .picMenu1.Image = imgMenuButtonFahrplanErstellen
            .picMenu2.Image = imgMenuButtonFavoriten
            .picMenu3.Image = imgMenuButtonEinstellungen
            .picMenu4.Image = imgMenuButtonUp
            .picMenu5.Image = imgMenuButtonHelp
            .picMenu6.Image = imgMenuButtonExit
        End With
    End Sub

    Public Sub SetServerVars()
        Analysis.OriginalVRR.ServerConfig.ServerAdress = "www.vrr.de"
        Analysis.OriginalVRR.ServerConfig.Port = "80"
        Analysis.OriginalVRR.ServerConfig.WebSite = "/de/fahrplanauskunft/index.html"

        Analysis.DeutscheBahn.ServerConfig.ServerAdress = "reiseauskunft.bahn.de"
        Analysis.DeutscheBahn.ServerConfig.Port = "80"
        Analysis.DeutscheBahn.ServerConfig.WebSite = "/bin/query.exe/dn?ld=212.147&seqnr=1&ident=" & "[<SessionID>]" & "&rt=1&rememberSortType=minDeparture&jumpToDetails=yes&HWAI=CONNECTION$C0-0!id=C0-0!HwaiConId=C0-0!HwaiDetailStatus=details!;CONNECTION$C0-1!id=C0-1!HwaiConId=C0-1!HwaiDetailStatus=details!;CONNECTION$C0-2!id=C0-2!HwaiConId=C0-2!HwaiDetailStatus=details!;CONNECTION$C0-0!id=C0-0!HwaiConId=C0-0!HwaiDetailStatus=details!;CONNECTION$C0-1!id=C0-1!HwaiConId=C0-1!HwaiDetailStatus=details!;CONNECTION$C0-2!id=C0-2!HwaiConId=C0-2!HwaiDetailStatus=details!;"
        Analysis.DeutscheBahn.ServerConfig.WebSite = "/bin/query.exe/dn?ld=212.147&rt=1&rememberSortType=minDeparture&jumpToDetails=yes&HWAI=CONNECTION$C0-0!id=C0-0!HwaiConId=C0-0!HwaiDetailStatus=details!;CONNECTION$C0-1!id=C0-1!HwaiConId=C0-1!HwaiDetailStatus=details!;CONNECTION$C0-2!id=C0-2!HwaiConId=C0-2!HwaiDetailStatus=details!;CONNECTION$C0-0!id=C0-0!HwaiConId=C0-0!HwaiDetailStatus=details!;CONNECTION$C0-1!id=C0-1!HwaiConId=C0-1!HwaiDetailStatus=details!;CONNECTION$C0-2!id=C0-2!HwaiConId=C0-2!HwaiDetailStatus=details!;"
    End Sub

    Public Sub SetOtherVars()
        FavoriteFilePath.HTMLPath = AppPath & "\Save\"
        FavoriteFilePath.RawPath = AppPath & "\Save\"
    End Sub

    Public Sub SetFahrPlanWindow()
        With frmFahrplan
            If Config.FahrPlanErstellen.AbfahrtOrAnkunft = "Abfahrt" Then
                .chkAbfahrt.Checked = True
            Else
                .chkAnkunft.Checked = True
            End If
            .cmbStartOrt.Text = Config.FahrPlanErstellen.LastStartOrt
            .cmbStartHalteStelle.Text = Config.FahrPlanErstellen.LastStartHalteStelle
            .cmbEndOrt.Text = Config.FahrPlanErstellen.LastEndOrt
            .cmbEndHalteStelle.Text = Config.FahrPlanErstellen.LastEndHalteStelle
            '.dtpDatum.Value = System.DateTime.Now
            .trbStunden.Value = System.DateTime.Now.Hour
            .trbMinuten.Value = System.DateTime.Now.Minute
            .txtZeit.Text = FormatTimeString(.trbStunden.Value, .trbMinuten.Value)
        End With
    End Sub


    Public Sub LoadConfigs()
        Call LoadConfig()
        Call LoadLastFahrPlan()
    End Sub

    Public Sub LoadQuickSelectData()
        Dim TempString(2) As String
        Dim TempCounter As Byte
        TempString(1) = LoadFile(AppPath & "\Config\orte.txt")
        QuickList.Staedte = Split(TempString(1), vbNewLine, 20)
        QuickList.StaedteAnzahl = QuickList.Staedte.Length
        TempString(2) = LoadFile(AppPath & "\Config\haltestellen.txt")
        QuickList.HalteStellen = Split(TempString(2), vbNewLine, 20)
        QuickList.HalteStellenAnzahl = QuickList.HalteStellen.Length

        With frmFahrplan
            For TempCounter = 0 To QuickList.StaedteAnzahl - 1
                If QuickList.Staedte(TempCounter) = "" Then Exit For
                .cmbStartOrt.Items.Add(QuickList.Staedte(TempCounter))
                .cmbEndOrt.Items.Add(QuickList.Staedte(TempCounter))
            Next
            For TempCounter = 0 To QuickList.HalteStellenAnzahl - 1
                If QuickList.HalteStellen(TempCounter) = "" Then Exit For
                .cmbStartHalteStelle.Items.Add(QuickList.HalteStellen(TempCounter))
                .cmbEndHalteStelle.Items.Add(QuickList.HalteStellen(TempCounter))
            Next
        End With
    End Sub

    Public Sub SetAnalysingVars()
        '|<->| is Placeholder for Numbers!
        With Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview
            .GesamtTrennung.Starter = "<a href=""#fahrt1"">1.Fahrt</a>"
            .GesamtTrennung.Ender = "</table>"

            .GruppenTrennung.Starter = "<a href=""#fahrt|<->|"">|<->|.Fahrt</a>"
            .GruppenTrennung.Ender = "</tr>" & vbNewLine & "<tr>"

            .Datum.Starter = "headers=""datelabel"">"
            .Datum.Ender = "</td>"

            .StartZeit.Starter = "headers=""ab"" style=""text-align:right;"">"
            .StartZeit.Ender = "</td>"

            .EndZeit.Starter = "headers=""an"">"
            .EndZeit.Ender = "</td>"

            .FahrtDauer.Starter = "headers=""dauer"">"
            .FahrtDauer.Ender = "</td>"

            .Umstiege.Starter = "headers=""umst"" style=""padding-left:8px;"">"
            .Umstiege.Ender = "</td>"
        End With
        With Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip
            .GesamtTrennung.Starter = "1. Fahrt</h3>"
            .GesamtTrennung.Ender = "<span class=""gray"">Alle Angaben ohne"

            .GruppenTrennung.Starter = "|<->|. Fahrt</h3>"
            .GruppenTrennung.Ender = "</table>"

            .StartZeit.Starter = "headers=""aban|<->|"">ab "
            .StartZeit.Ender = "</td>"

            .StartPunkt.Starter = "headers=""stop|<->|"">"
            .StartPunkt.Ender = "</td>"

            .FahrZeugTyp.Starter = "headers=""verkehrsmittel|<->|"" rowspan=""2"">"
            .FahrZeugTyp.Ender = "</td>"

            .EndZeit.Starter = "headers=""aban|<->|"">an "
            .EndZeit.Ender = "</td>"

            .EndPunkt.Starter = "headers=""stop|<->|"">"
            .EndPunkt.Ender = "</td>"
        End With
        With Analysis.OriginalVRR.Len.AnalyseTripOverviewLen
            .GesamtTrennung.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.GesamtTrennung.Starter)
            .GesamtTrennung.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.GesamtTrennung.Ender)

            .GruppenTrennung.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.GruppenTrennung.Starter)
            .GruppenTrennung.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.GruppenTrennung.Ender)

            .Datum.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.Datum.Starter)
            .Datum.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.Datum.Ender)

            .StartZeit.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.StartZeit.Starter)
            .StartZeit.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.StartZeit.Ender)

            .EndZeit.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.EndZeit.Starter)
            .EndZeit.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.EndZeit.Ender)

            .FahrtDauer.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.FahrtDauer.Starter)
            .FahrtDauer.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.FahrtDauer.Ender)

            .Umstiege.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.Umstiege.Starter)
            .Umstiege.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTripOverview.Umstiege.Ender)
        End With
        With Analysis.OriginalVRR.Len.AnalyseTripLen
            .GesamtTrennung.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.GesamtTrennung.Starter)
            .GesamtTrennung.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.GesamtTrennung.Ender)

            .GruppenTrennung.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.GruppenTrennung.Starter)
            .GruppenTrennung.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.GruppenTrennung.Ender)

            .StartZeit.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.StartZeit.Starter)
            .StartZeit.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.StartZeit.Ender)

            .StartPunkt.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.StartPunkt.Starter)
            .StartPunkt.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.StartPunkt.Ender)

            .FahrZeugTyp.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.FahrZeugTyp.Starter)
            .FahrZeugTyp.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.FahrZeugTyp.Ender)

            .EndZeit.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.EndZeit.Starter)
            .EndZeit.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.EndZeit.Ender)

            .EndPunkt.Starter = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.EndPunkt.Starter)
            .EndPunkt.Ender = Len(Analysis.OriginalVRR.AnalyseHTML.AnalyseTrip.EndPunkt.Ender)
        End With

        '|<->| is Placeholder for Numbers!
        With Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview
            .GesamtTrennung.Starter = ""
            .GesamtTrennung.Ender = ""

            .GruppenTrennung.Starter = "<tr class="" firstrow"">"
            .GruppenTrennung.Ender = "<tr id="

            .Datum.Starter = "<td class=""date"">"
            .Datum.Ender = "</td>"

            .StartZeit.Starter = "<td class=""time"">"
            .StartZeit.Ender = "</td>"

            .FahrtDauer.Starter = "<td class=""duration lastrow"" rowspan=""2"">"
            .FahrtDauer.Ender = "</td>"

            .Umstiege.Starter = "<td class=""changes lastrow"" rowspan=""2"">"
            .Umstiege.Ender = "</td>"

            .EndZeit.Starter = "<td class=""time"">"
            .EndZeit.Ender = "</td>"
        End With
        With Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip
            .GesamtTrennung.Starter = ""
            .GesamtTrennung.Ender = ""

            .GruppenTrennung.Starter = "id=""trC0-|<->|"""
            .GruppenTrennung.Ender = "class=""moreDetailContainer"""

            .StartPunkt.Starter = "<td style=""width:190px; height: 16px; white-space: normal;"">"
            .StartPunkt.Ender = "</td>"

            .StartDatum.Starter = "<td class=""nowrap"" style=""width:70px;"">"
            .StartDatum.Ender = "</td>"

            .StartZeit.Starter = "<td class=""nowrap"" style=""width:45px;"">"
            .StartZeit.Ender = "</td>"

            .StartGleis.Starter = "<td class=""nowrap platform"" style=""width:50px;"">"
            .StartGleis.Ender = "</td>"

            .FahrZeugTyp.Starter = "<td rowspan=""2"" class=""nowrap lastrow"" style=""width:60px;"">"
            .FahrZeugTyp.Ender = "</td>"

            .EndPunkt.Starter = "<td style=""white-space: normal;"">"
            .EndPunkt.Ender = "</td>"

            .EndDatum.Starter = "<td>"
            .EndDatum.Ender = "</td>"

            .EndZeit.Starter = "<td class=""nowrap"" >"
            .EndZeit.Ender = "</td>"

            .EndGleis.Starter = "<td class=""nowrap platform"">"
            .EndGleis.Ender = "</td>"

            .TripPreCount.Starter = "<tr class=""last"">"
        End With
        With Analysis.DeutscheBahn.Len.AnalyseTripOverviewLen
            .GesamtTrennung.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.GesamtTrennung.Starter)
            .GesamtTrennung.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.GesamtTrennung.Ender)

            .GruppenTrennung.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.GruppenTrennung.Starter)
            .GruppenTrennung.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.GruppenTrennung.Ender)

            .Datum.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.Datum.Starter)
            .Datum.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.Datum.Ender)

            .StartZeit.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.StartZeit.Starter)
            .StartZeit.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.StartZeit.Ender)

            .EndZeit.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.EndZeit.Starter)
            .EndZeit.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.EndZeit.Ender)

            .FahrtDauer.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.FahrtDauer.Starter)
            .FahrtDauer.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.FahrtDauer.Ender)

            .Umstiege.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.Umstiege.Starter)
            .Umstiege.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTripOverview.Umstiege.Ender)
        End With
        With Analysis.DeutscheBahn.Len.AnalyseTripLen
            .GesamtTrennung.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.GesamtTrennung.Starter)
            .GesamtTrennung.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.GesamtTrennung.Ender)

            .GruppenTrennung.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.GruppenTrennung.Starter)
            .GruppenTrennung.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.GruppenTrennung.Ender)

            .StartDatum.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartDatum.Starter)
            .StartDatum.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartDatum.Ender)

            .StartZeit.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartZeit.Starter)
            .StartZeit.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartZeit.Ender)

            .StartGleis.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartGleis.Starter)
            .StartGleis.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartGleis.Ender)

            .StartPunkt.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartPunkt.Starter)
            .StartPunkt.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.StartPunkt.Ender)

            .FahrZeugTyp.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.FahrZeugTyp.Starter)
            .FahrZeugTyp.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.FahrZeugTyp.Ender)

            .EndDatum.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndDatum.Starter)
            .EndDatum.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndDatum.Ender)

            .EndZeit.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndZeit.Starter)
            .EndZeit.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndZeit.Ender)

            .EndGleis.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndGleis.Starter)
            .EndGleis.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndGleis.Ender)

            .EndPunkt.Starter = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndPunkt.Starter)
            .EndPunkt.Ender = Len(Analysis.DeutscheBahn.AnalyseHTML.AnalyseTrip.EndPunkt.Ender)
        End With
    End Sub

    Public Sub SetTemplateVars()
        With TemplateVars.TripConfig
            .StartCity = "[<StartCity>]"
            .StartPoint = "[<StartPoint>]"
            .FinishCity = "[<FinishCity>]"
            .FinishPoint = "[<FinishPoint>]"
            .AbfahrtOrAnkunft = "[<TripDepArr>]"
            .UhrZeit = "[<TripTime>]"
            .Datum = "[<TripDate>]"
        End With

        With TemplateVars.Overview
            .StartEnd.Starter = "[<StartTemplateOverview>]"
            .GroupStartDate = "[<GroupStartDate>]"
            .GroupStartTime = "[<GroupStartTime>]"
            .GroupFinishTime = "[<GroupFinishTime>]"
            .GroupTripTime = "[<GroupTripTime>]"
            .GroupChanges = "[<GroupChanges>]"
            .GroupNumber = "[<GroupNumber>]"
            .StartEnd.Ender = "[<EndTemplateOverview>]"
        End With

        With TemplateVars.Trips
            .StartEnd.Starter = "[<StartTemplateTrips>]"
            .TripNumber = "[<TripNumber>]"
            With .SpecialTrips
                .StartEnd.Starter = "[<StartTemplateSpecial>]"
                .SpecialNumber = "[<SpecialNumber>]"
                .SpecialStartTime = "[<SpecialStartTime>]"
                .SpecialStartStop = "[<SpecialStartStop>]"
                .SpecialBus = "[<SpecialBus>]"
                .SpecialFinishTime = "[<SpecialFinishTime>]"
                .SpecialFinishStop = "[<SpecialFinishStop>]"
                .StartEnd.Ender = "[<EndTemplateSpecial>]"
            End With
            .StartEnd.Ender = "[<EndTemplateTrips>]"
        End With
    End Sub
End Module
