Module StructureVars
    Public Enum MenuTree
        Back = -10
        MainMenu = 0
        FahrPlanErstellenOrt = 10
        FahrPlanErstellenZeit = 11
        FahrPlanErstellenErweitert = 12
        FahrPlanAnzeigen = 13
        Favoriten = 20
        Einstellungen = 30
        Debug = 40
        Hilfe = 50
        SelectFile = 90
    End Enum

    Public Structure Configuration
        Dim FahrPlanErstellen As FahrPlanErstellenConfig
        Dim Provider As String
        Dim OldFahrPlanNode As String
        Dim TemplateName As String
        Dim TemplatePath As String
        Dim TemplateFile As String
        Dim NeedProxy As String
        Dim ProxyURL As String
        Dim ProxyPort As String
        Dim ProxyUser As String
        Dim ProxyPass As String
    End Structure

    Public Structure QuickListStr
        Dim Staedte() As String
        Dim StaedteAnzahl As Byte
        Dim HalteStellen() As String
        Dim HalteStellenAnzahl As Byte
    End Structure

    Public Structure FahrPlanErstellenConfig
        Dim Standard As FahrPlanStandard
        Dim ConfigKeepSave As ConfigKeepSave
        Dim LastStartOrt As String
        Dim LastEndOrt As String
        Dim LastStartHalteStelle As String
        Dim LastEndHalteStelle As String
        Dim AbfahrtOrAnkunft As String
    End Structure

    Public Structure FahrPlanStandard
        Dim StartOrt As String
        Dim EndOrt As String
        Dim StartHalteStelle As String
        Dim EndHalteStelle As String
    End Structure

    Public Structure ConfigKeepSave
        Dim LastStartOrt As String
        Dim LastEndOrt As String
        Dim LastStartHalteStelle As String
        Dim LastEndHalteStelle As String
    End Structure

    Public Structure FahrPlanProvider
        Dim OriginalVRR As OriginalVRR
        Dim GlobalVRR As GlobalVRR
        Dim MVV As MVV
        Dim DeutscheBahn As DeutscheBahn
    End Structure

    Public Structure OriginalVRR
        Dim ServerConfig As ServerConfig
        Dim AnalyseHTML As AnalyseHTML
        Dim Len As GiveLen
    End Structure

    Public Structure GlobalVRR
        Dim ServerConfig As ServerConfig
        Dim AnalyseHTML As AnalyseHTML
        Dim Len As GiveLen
    End Structure

    Public Structure MVV
        Dim ServerConfig As ServerConfig
        Dim AnalyseHTML As AnalyseHTML
        Dim Len As GiveLen
    End Structure

    Public Structure DeutscheBahn
        Dim ServerConfig As ServerConfig
        Dim AnalyseHTML As AnalyseHTML
        Dim Len As GiveLen
    End Structure

    Public Structure ServerConfig
        Dim ServerAdress As String
        Dim Port As String
        Dim WebSite As String
    End Structure

    Public Structure GiveLen
        Dim AnalyseTripOverviewLen As AnalyseTripOverviewLen
        Dim AnalyseTripLen As AnalyseTripLen
    End Structure

    Public Structure AnalyseTripOverviewLen
        Dim GesamtTrennung As AnalyseStartEndLen
        Dim GruppenTrennung As AnalyseStartEndLen
        Dim Datum As AnalyseStartEndLen
        Dim StartZeit As AnalyseStartEndLen
        Dim EndZeit As AnalyseStartEndLen
        Dim FahrtDauer As AnalyseStartEndLen
        Dim Umstiege As AnalyseStartEndLen
    End Structure

    Public Structure AnalyseTripLen
        Dim GesamtTrennung As AnalyseStartEndLen
        Dim GruppenTrennung As AnalyseStartEndLen
        Dim StartZeit As AnalyseStartEndLen
        Dim StartDatum As AnalyseStartEndLen
        Dim StartPunkt As AnalyseStartEndLen
        Dim StartGleis As AnalyseStartEndLen
        Dim FahrZeugTyp As AnalyseStartEndLen
        Dim EndZeit As AnalyseStartEndLen
        Dim EndDatum As AnalyseStartEndLen
        Dim EndPunkt As AnalyseStartEndLen
        Dim EndGleis As AnalyseStartEndLen
        Dim TripPreCount As AnalyseStartEndLen
    End Structure

    Public Structure AnalyseStartEndLen
        Dim Starter As Integer
        Dim Ender As Integer
    End Structure

    Public Structure AnalyseHTML
        Dim AnalyseTripOverview As AnalyseTripOverview
        Dim AnalyseTrip As AnalyseTrip
    End Structure

    Public Structure AnalyseTripOverview
        Dim GesamtTrennung As AnalyseStartEnd
        Dim GruppenTrennung As AnalyseStartEnd
        Dim Datum As AnalyseStartEnd
        Dim StartZeit As AnalyseStartEnd
        Dim EndZeit As AnalyseStartEnd
        Dim FahrtDauer As AnalyseStartEnd
        Dim Umstiege As AnalyseStartEnd
    End Structure

    Public Structure AnalyseTrip
        Dim GesamtTrennung As AnalyseStartEnd
        Dim GruppenTrennung As AnalyseStartEnd
        Dim StartZeit As AnalyseStartEnd
        Dim StartDatum As AnalyseStartEnd
        Dim StartPunkt As AnalyseStartEnd
        Dim StartGleis As AnalyseStartEnd
        Dim FahrZeugTyp As AnalyseStartEnd
        Dim EndZeit As AnalyseStartEnd
        Dim EndDatum As AnalyseStartEnd
        Dim EndPunkt As AnalyseStartEnd
        Dim EndGleis As AnalyseStartEnd
        Dim TripPreCount As AnalyseStartEnd
    End Structure

    Public Structure AnalyseStartEnd
        Dim Starter As String
        Dim Ender As String
    End Structure

    Public Structure Template
        Dim TripConfig As TemplateTripConfig
        Dim Overview As TemplateOverview
        Dim Trips As TemplateTrips
    End Structure

    Public Structure TemplateTripConfig
        Dim StartCity As String
        Dim StartPoint As String
        Dim FinishCity As String
        Dim FinishPoint As String
        Dim AbfahrtOrAnkunft As String
        Dim UhrZeit As String
        Dim Datum As String
    End Structure

    Public Structure TemplateOverview
        Dim StartEnd As AnalyseStartEnd
        Dim GroupStartDate As String
        Dim GroupStartTime As String
        Dim GroupFinishTime As String
        Dim GroupTripTime As String
        Dim GroupChanges As String
        Dim GroupNumber As String
    End Structure

    Public Structure TemplateTrips
        Dim SpecialTrips As TemplateSpecialTrips
        Dim TripNumber As String
        Dim StartEnd As AnalyseStartEnd
    End Structure

    Public Structure TemplateSpecialTrips
        Dim StartEnd As AnalyseStartEnd
        Dim SpecialNumber As String
        Dim SpecialStartTime As String
        Dim SpecialStartStop As String
        Dim SpecialBus As String
        Dim SpecialFinishTime As String
        Dim SpecialFinishStop As String
    End Structure

    Public Structure FahrPlanDaten
        Dim FahrPlanOverView As FahrPlanOverView
        Dim FahrplanMain As FahrPlanMain
    End Structure

    Public Structure FahrPlanMain
        Dim StartZeit As String
        Dim EndZeit As String
        Dim StartPunkt As String
        Dim EndPunkt As String
        Dim FahrZeugTyp As String
        Dim AnzahlTrips As Byte
    End Structure

    Public Structure FahrPlanOverView
        Dim Datum As String
        Dim StartZeit As String
        Dim EndZeit As String
        Dim FahrtDauer As String
        Dim Umstiege As String
        Dim AnzahlFahrten As Byte
    End Structure

    Public Structure WunschFahrPlan
        Dim StartOrt As String
        Dim StartHalteStelle As String
        Dim EndOrt As String
        Dim EndHalteStelle As String

        Dim UhrZeit As UhrZeit
        Dim Datum As Datum

        Dim AbfahrtOrAnkunft As String
        Dim Umstiege As String
        Dim LinienArt As LineRestrictions
    End Structure

    Public Structure UhrZeit
        Dim Stunden As String
        Dim Minuten As String
    End Structure

    Public Structure Datum
        Dim Tag As String
        Dim Monat As String
        Dim Jahr As String
    End Structure

    Public Structure FilePaths
        Dim HTMLPath As String
        Dim HTMLFileName As String
        Dim RawPath As String
        Dim RawFileName As String
        Dim LoadFilePath As String
        Dim Which As String
    End Structure

    Public Enum LineRestrictions
        Alle = 400
        KeinICE = 401
        VerbundsLinien = 403
    End Enum

    Public Enum ReplaceDirection
        NormalToByte = 0
        ByteToNormal = 1
    End Enum

    Public Version As String = "0.9.8"
    Public AppPath As String

    Public imgThumbButtonCheck As System.Drawing.Image
    Public imgThumbButtonBack As System.Drawing.Image
    Public imgThumbButtonDown As System.Drawing.Image

    Public imgMenuButtonFahrplanErstellen As System.Drawing.Image
    Public imgMenuButtonEinstellungen As System.Drawing.Image
    Public imgMenuButtonFavoriten As System.Drawing.Image
    Public imgMenuButtonHelp As System.Drawing.Image
    Public imgMenuButtonExit As System.Drawing.Image
    Public imgMenuButtonUp As System.Drawing.Image
    Public imgMenuButtonDown As System.Drawing.Image

    Public CurrentMenu As MenuTree
    Public LastMenu As MenuTree

    Public RawHTML As String
    Public Analysis As FahrPlanProvider
    Public FahrPlan(16, 32) As FahrPlanDaten
    Public ErstellterFahrplan As WunschFahrPlan
    Public TemplateVars As Template

    Public TemplateNames(256) As String

    Public Config As Configuration
    Public QuickList As QuickListStr
    Public TempDate As Datum
    Public FavoriteFilePath As FilePaths
End Module
