Module TemplateFunctions
    Public Sub CompileTemplate(Optional ByVal AlternativePath As String = "")
        Dim sWholeTemplate As String
        Dim iCounterGroup, iSpecialID As Byte
        Dim TemplateData(7) As String

        TemplateData(0) = LoadFile(Config.TemplateFile)
        TemplateData(1) = Left(TemplateData(0), InStr(1, TemplateData(0), "[<StartTemplateOverview>]") - 1)
        TemplateData(0) = Mid(TemplateData(0), InStr(1, TemplateData(0), "[<StartTemplateOverview>]") + Len("[<StartTemplateOverview>]"))
        TemplateData(2) = Left(TemplateData(0), InStr(1, TemplateData(0), "[<EndTemplateOverview>]") - 1)
        TemplateData(0) = Mid(TemplateData(0), InStr(1, TemplateData(0), "[<EndTemplateOverview>]") + Len("[<EndTemplateOverview>]"))
        TemplateData(3) = Left(TemplateData(0), InStr(1, TemplateData(0), "[<StartTemplateTrips>]") - 1)
        TemplateData(0) = Mid(TemplateData(0), InStr(1, TemplateData(0), "[<StartTemplateTrips>]") + Len("[<StartTemplateTrips>]"))
        TemplateData(4) = Left(TemplateData(0), InStr(1, TemplateData(0), "[<StartTemplateSpecial>]") - 1)
        TemplateData(0) = Mid(TemplateData(0), InStr(1, TemplateData(0), "[<StartTemplateSpecial>]") + Len("[<StartTemplateSpecial>]"))
        TemplateData(5) = Left(TemplateData(0), InStr(1, TemplateData(0), "[<EndTemplateSpecial>]") - 1)
        TemplateData(0) = Mid(TemplateData(0), InStr(1, TemplateData(0), "[<EndTemplateSpecial>]") + Len("[<EndTemplateSpecial>]"))
        TemplateData(6) = Left(TemplateData(0), InStr(1, TemplateData(0), "[<EndTemplateTrips>]") - 1)
        TemplateData(0) = Mid(TemplateData(0), InStr(1, TemplateData(0), "[<EndTemplateTrips>]") + Len("[<EndTemplateTrips>]"))
        TemplateData(7) = TemplateData(0)

        sWholeTemplate = TemplateData(1)
        With ErstellterFahrplan
            sWholeTemplate = Replace(sWholeTemplate, "[<StartCity>]", .StartOrt)
            sWholeTemplate = Replace(sWholeTemplate, "[<StartPoint>]", .StartHalteStelle)
            sWholeTemplate = Replace(sWholeTemplate, "[<FinishCity>]", .EndOrt)
            sWholeTemplate = Replace(sWholeTemplate, "[<FinishPoint>]", .EndHalteStelle)

            If .AbfahrtOrAnkunft = "arr" Then
                sWholeTemplate = Replace(sWholeTemplate, "[<TripDepArr>]", "Ankunft")
            Else
                sWholeTemplate = Replace(sWholeTemplate, "[<TripDepArr>]", "Abfahrt")
            End If

            sWholeTemplate = Replace(sWholeTemplate, "[<TripTime>]", .UhrZeit.Stunden & ":" & .UhrZeit.Minuten)
            sWholeTemplate = Replace(sWholeTemplate, "[<TripDate>]", .Datum.Tag & "." & .Datum.Monat & "." & .Datum.Jahr)
        End With

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            With FahrPlan(iCounterGroup, 0).FahrPlanOverView
                sWholeTemplate = sWholeTemplate & TemplateData(2)
                sWholeTemplate = Replace(sWholeTemplate, "[<GroupStartDate>]", .Datum)
                sWholeTemplate = Replace(sWholeTemplate, "[<GroupStartTime>]", .StartZeit)
                sWholeTemplate = Replace(sWholeTemplate, "[<GroupFinishTime>]", .EndZeit)
                sWholeTemplate = Replace(sWholeTemplate, "[<GroupTripTime>]", .FahrtDauer)
                sWholeTemplate = Replace(sWholeTemplate, "[<GroupChanges>]", .Umstiege)
                sWholeTemplate = Replace(sWholeTemplate, "[<GroupNumber>]", iCounterGroup)
            End With
        Next

        sWholeTemplate = sWholeTemplate & TemplateData(3)

        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            sWholeTemplate = sWholeTemplate & TemplateData(4)
            sWholeTemplate = Replace(sWholeTemplate, "[<TripNumber>]", iCounterGroup)
            For iSpecialID = 1 To FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
                With FahrPlan(iCounterGroup, iSpecialID).FahrplanMain
                    Dim sTempReplace As String
                    sTempReplace = .FahrZeugTyp
                    sTempReplace = Replace(sTempReplace, "Schw-B", "Schwebebahn ")
                    sTempReplace = Replace(sTempReplace, "Schwebebahn", "<img src=""schwebebahn.gif""> Schwebebahn")
                    sTempReplace = Replace(sTempReplace, "Bus", "<img src=""bus.gif""> Bus")
                    sTempReplace = Replace(sTempReplace, "Niederflurbus", "<img src=""nf_bus.gif""> Niederflurbus")
                    sTempReplace = Replace(sTempReplace, "S-Bahn", "<img src=""s_Bahn.gif""> S-Bahn")
                    sTempReplace = Replace(sTempReplace, "R-Bahn", "<img src=""train.gif""> R-Bahn")
                    sTempReplace = Replace(sTempReplace, "RB ", "<img src=""train.gif""> RB ")
                    sTempReplace = Replace(sTempReplace, "S ", "<img src=""train.gif""> S&ensp;")
                    sTempReplace = Replace(sTempReplace, "IRE ", "<img src=""train.gif""> IRE&ensp;")
                    sTempReplace = Replace(sTempReplace, "RE ", "<img src=""train.gif""> RE ")
                    sTempReplace = Replace(sTempReplace, "IC ", "<img src=""train.gif""> IC ")
                    sTempReplace = Replace(sTempReplace, "ICE ", "<img src=""train.gif""> ICE ")
                    sTempReplace = Replace(sTempReplace, "EN ", "<img src=""train.gif""> EN ")
                    sTempReplace = Replace(sTempReplace, "CNL ", "<img src=""train.gif""> CNL ")
                    sTempReplace = Replace(sTempReplace, "NZ ", "<img src=""train.gif""> NZ ")
                    sTempReplace = Replace(sTempReplace, "EC ", "<img src=""train.gif""> EC ")
                    sTempReplace = Replace(sTempReplace, "DB ", "<img src=""train.gif""> DB ")
                    sTempReplace = Replace(sTempReplace, "NWB ", "<img src=""train.gif""> NWB ")
                    sTempReplace = Replace(sTempReplace, "ME ", "<img src=""train.gif""> EC ")
                    sTempReplace = Replace(sTempReplace, "nicht umsteigen", "<img src=""attention.gif""> nicht umsteigen ")
                    sTempReplace = Replace(sTempReplace, "Anschluss", "<img src=""walk.gif""> Anschluss ")
                    sTempReplace = Replace(sTempReplace, "Fuweg", "<img src=""walk.gif""> Fuweg ")
                    sTempReplace = Replace(sTempReplace, "Fu&szlig;weg", "<img src=""walk.gif""> Fu&szlig;weg ")
                    sTempReplace = Replace(sTempReplace, "Fu&#223;weg", "<img src=""walk.gif""> Fu&#223;weg ")
                    sTempReplace = Replace(sTempReplace, "<img src=""", "<img src=""" & Config.TemplatePath & "\")

                    sWholeTemplate = sWholeTemplate & TemplateData(5)
                    sWholeTemplate = Replace(sWholeTemplate, "[<SpecialNumber>]", iSpecialID)
                    sWholeTemplate = Replace(sWholeTemplate, "[<SpecialStartTime>]", .StartZeit)
                    sWholeTemplate = Replace(sWholeTemplate, "[<SpecialStartStop>]", .StartPunkt)
                    sWholeTemplate = Replace(sWholeTemplate, "[<SpecialBus>]", sTempReplace)
                    sWholeTemplate = Replace(sWholeTemplate, "[<SpecialFinishTime>]", .EndZeit)
                    sWholeTemplate = Replace(sWholeTemplate, "[<SpecialFinishStop>]", .EndPunkt)
                End With
            Next
            sWholeTemplate = sWholeTemplate & TemplateData(6)
        Next
        sWholeTemplate = Replace(sWholeTemplate, "[<TemplatePath>]", Config.TemplatePath & "\")
        sWholeTemplate = sWholeTemplate & TemplateData(7)
        sWholeTemplate = Replace(sWholeTemplate, "", "&auml;")
        sWholeTemplate = Replace(sWholeTemplate, "", "&uuml;")
        sWholeTemplate = Replace(sWholeTemplate, "", "&ouml;")
        sWholeTemplate = Replace(sWholeTemplate, "", "&szlig;")
        If AlternativePath = "" Then
            Call SaveFile(AppPath & "\Temp\Fahrplan.htm", sWholeTemplate)
            Try
                Call CompileTree()
                frmFahrplan.webFahrPlanAnzeigen.Navigate(New System.Uri(AppPath & "\Temp\Fahrplan.htm"))
            Catch
            End Try
            frmFahrplan.tabFahrPlanAnzeige.SelectedIndex = 0
        Else
            Call SaveFile(AlternativePath, sWholeTemplate)
        End If
    End Sub

    Private Function FixHTML(ByVal source As String) As String
        source = System.Text.RegularExpressions.Regex.Replace(source, "<.*?>", String.Empty)

        Return source
    End Function

    Public Sub CompileTree()
        Dim tempID As Integer
        Dim tempSubID As Integer
        frmFahrplan.tvwFahrplanAnzeigen.Nodes.Clear()
        For iCounterGroup = 1 To FahrPlan(0, 0).FahrPlanOverView.AnzahlFahrten
            With FahrPlan(iCounterGroup, 0).FahrPlanOverView
                tempID = frmFahrplan.tvwFahrplanAnzeigen.Nodes.Add("Verbindung " & iCounterGroup & " - " & FixHTML(.FahrtDauer) & "(" & FixHTML(.Umstiege) & ")").Index
                Call SaveFile(AppPath & "\Temp\Debug" & tempID, FixHTML(.FahrtDauer))
                tempSubID = frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes.Add("Verbindungs Infos").Index

                frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes(tempSubID).Nodes.Add("Datum: " & FixHTML(.Datum))
                frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes(tempSubID).Nodes.Add("Uhrzeit: " & FixHTML(.StartZeit) & "-" & FixHTML(.EndZeit) & "(" & FixHTML(.FahrtDauer) & ")")
            End With
            For iSpecialID = 1 To FahrPlan(iCounterGroup, 0).FahrplanMain.AnzahlTrips
                With FahrPlan(iCounterGroup, iSpecialID).FahrplanMain
                    tempSubID = frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes.Add("Trip " & iSpecialID).Index

                    frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes(tempSubID).Nodes.Add("Fahrzeug: " & FixHTML(.FahrZeugTyp))
                    frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes(tempSubID).Nodes.Add("Einstieg: " & FixHTML(.StartZeit) & " " & FixHTML(.StartPunkt))
                    frmFahrplan.tvwFahrplanAnzeigen.Nodes(tempID).Nodes(tempSubID).Nodes.Add("Ausstieg: " & FixHTML(.EndZeit) & " " & FixHTML(.EndPunkt))
                End With
            Next
        Next
    End Sub
End Module
