var names=new Array();
var values=new Array();

/**
 * Utility function to add a stop to an internal array
 * @param name the name of the stop
 * @param a string containing "omc:id"
 */
function addToStopsArray(name, value)
{
	names[names.length]=name;
	values[values.length]=value;
}

/**
 * Sends back the result as a list of stops.
 * @param names an array of String, containing the stop names
 * @param values an array of String, containing "omc:id"
 */
function sendResultStops()
{	
	// if we have a parent window
	if (window.opener)
	{
		var result = window.opener.odvMapResult;

		// if we found the result object to write to
		if (result)
		{
			// go through the list of stops and add them
			for (i=0; i<names.length; i++)
			{
				result.stopNameList[i]=names[i];
				result.stopList[i]=values[i];	
			}
			result.type="stop";
			result.placeName="";
			
			window.opener.setMapInput();
			window.opener.focus();
			window.close();
		}
	}
}


/**
 * Sends back the result by setting description, omc and id of a POI.
 * @param name the name of the POI
 * @param omc the official municipality code of the city the POI is in
 * @param id the id of the POI
 */
function sendResultPOI(name, omc, id)
{
	// if we have a parent window
	if (window.opener)
	{
		var result = window.opener.odvMapResult;

		// if we found the result object to write to
		if (result)
		{
			result.type = "poi";
			result.placeName = "";
			result.placeID = -1;
			result.desc = name;
			result.omc = omc;
			result.poiID = id;

			window.opener.setMapInput();
			window.opener.focus();
			window.close();
		}
	}
}



/**
 * Send back the map center as result.
 * @param desc the Name of the street nearest to the map center
 * @param the coordinates
 */
function sendResultMapCenter(desc, coord)
{
	//alert("Selected center: "+desc+"\n coords="+coord);
	// if we have a parent window
	if (window.opener)
	{
		var result = window.opener.odvMapResult;

		// if we found the result object to write to
		if (result)
		{
			result.desc = desc;
			result.coordValue = coord;

			window.opener.setMapInput();
			window.opener.focus();
			window.close();
		}
	}
}

function mapResult()
{
	this.type		= "address";

	this.centerX		= 0;
	this.centerY		= 0;
	this.mapName		= "";
	this.coordValue		= "";
	this.desc		= "";

	this.placeName		= "";
	this.omc		= 0;
	this.placeID		= 0;

	this.streetName		= "";
	this.streetID		= 0;
	
	this.poiID		= 0;
  
  //added: dg
  this.stopName = ".";
  
	this.stopList		= new Array();
	this.stopNameList	= new Array();
}

function mapRequest()
{
	this.odvMap		= null;
	this.mapUsage	= "unknown";
	this.mapType	= "unknown";
	this.objectList = new Array();
}

var odvMapResult  = new mapResult();
var odvMapRequest = new mapRequest();

function setMapInput()
{
  obj = document.fahrplan.elements['command'];
  if (obj) odvMapRequest.mapUsage = obj.value;
  	
	if (odvMapResult && odvMapRequest.mapUsage)
	{
		if (odvMapResult.type == "address")
		{
     
			obj = document.fahrplan.elements['typeInfo_'+odvMapRequest.mapUsage];
			if (obj) obj.value = "coord";
			
			obj = document.fahrplan.elements['nameInfo_'+odvMapRequest.mapUsage];
			if (obj) obj.value = odvMapResult.coordValue;

			if (odvMapRequest.mapUsage!='dm'){
				obj = document.fahrplan.elements['execInst'];
				if (obj) obj.value = "verifyOnly";
			}

			document.fahrplan.submit();
		}
		else if (odvMapResult.type == "poi")
		{
			var obj = document.fahrplan.elements['placeInfo_'+odvMapRequest.mapUsage]; 
			if (obj) obj.value = odvMapResult.omc + ":" + odvMapResult.placeID;

			obj = document.fahrplan.elements['typeInfo_'+odvMapRequest.mapUsage];
			if (obj) obj.value = "poiID";
			
			obj = document.fahrplan.elements['nameInfo_'+odvMapRequest.mapUsage];
			if (obj) obj.value = odvMapResult.poiID;

			if (odvMapRequest.mapUsage!='dm'){
				obj = document.fahrplan.elements['execInst'];
				if (obj) obj.value = "verifyOnly";
			}

			document.fahrplan.submit();
		}
		else if (odvMapResult.type == "stop")
		{
			var obj = document.fahrplan.elements['placeInfo_'+odvMapRequest.mapUsage];
			if (obj) obj.value = "";

			obj = document.fahrplan.elements['typeInfo_'+odvMapRequest.mapUsage];
			if (obj) obj.value = "stopID";

			var obj = document.fahrplan.elements['nameInfo_'+odvMapRequest.mapUsage];
			if (obj) 
			{
				obj.value = "";
				for (var iStop = 0; iStop < odvMapResult.stopList.length; iStop++)
				{
					if (iStop > 0) obj.value += ":";
					obj.value += odvMapResult.stopList[iStop];
				}				
			}

			if (odvMapRequest.mapUsage!='dm'){
				obj = document.fahrplan.elements['execInst'];
				if (obj) obj.value = "verifyOnly";
			}

			obj = document.fahrplan.elements['deleteAssignedStops_'+odvMapRequest.mapUsage];
			if (obj) obj.value = '1';

			document.fahrplan.submit();
		}
	}
}

/**
  * Popup for images (teaser zoom)
  * @param imgurl the url of the image displayed in the popup
  */
function openImgPopup(imgurl) {
        window.open(imgurl, "imgpopup", "left=200,top=200,width=560,height=480,resizable=yes,status=0,menubar=0,scrollbars=yes");
}

/* functions for contact formular */
    var isClicked = 0;

    function setClicked() {
      isClicked = 1;
    }

    function sendForm() {
      if(!isClicked) return;
      document.kontakt.submit();
      return 1;
    }

